--Because I love chaos.

local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
--local MAXSKINCOLORS = MAXSKINCOLORS
--local ANG1 = ANG1
--local k_sneakertimer = k_sneakertimer
--local k_spinouttimer = k_spinouttimer
--local k_wipeoutslow = k_wipeoutslow
--local k_driftboost = k_driftboost
--local k_floorboost = k_floorboost
--local k_startboost = k_startboost
local k_itemamount = k_itemamount
--local k_itemtype = k_itemtype
--local k_rocketsneakertimer = k_rocketsneakertimer
--local k_hyudorotimer = k_hyudorotimer
--local k_drift = k_drift
--local k_speedboost = k_speedboost
--local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
--local k_growshrinktimer = k_growshrinktimer
--local k_throwdir = k_throwdir

--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount (animation frames become amount frames)

freeslot(
	"SPR_XEMR"
)


local masteremeraldcd = 0
addHook("MapLoad", function()
	masteremeraldcd = 0
end)

addHook("NetVars", function(net)
	masteremeraldcd = net($)
end)


local function GetSuper(p,i)
	S_StartSound(p.mo, sfx_cgot, p)
			
	if (chaosdrives) then -- Because theming
		p.cd_run = min ($ + (FixedRound(chaosdrives.max*FRACUNIT/5)/FRACUNIT), chaosdrives.max)
		p.cd_swim = min ($ + (FixedRound(chaosdrives.max*FRACUNIT/5)/FRACUNIT), chaosdrives.max)
		p.cd_fly = min ($ + (FixedRound(chaosdrives.max*FRACUNIT/5)/FRACUNIT), chaosdrives.max)
		p.cd_power = min ($ + (FixedRound(chaosdrives.max*FRACUNIT/5)/FRACUNIT), chaosdrives.max)		
	end
end

local function UseSuper(p,cmd)
	local pks = p.kartstuff
	
	p.hugequest.sparkle = 15*TICRATE+1
	pks[k_invincibilitytimer] = p.hugequest.sparkle
	p.hugequest.huge = 2
	pks[k_itemamount] = $-1
	p.hugequest.super = 1

	if not p.mo.hqtrans then
		S_ChangeMusic("HQSUPR", true, p)
	end
	
	K_PlayPowerGloatSound(p.mo)
	
	masteremeraldcd = 10*TICRATE -- No consecutive Emerald pulls, maybe
end

local function MasterEmeraldTimer()
	masteremeraldcd = max($-1, 0)
end
addHook("ThinkFrame", MasterEmeraldTimer)

local function EmeraldOdds(newodds, pos, mashed, rush, p, secondist, pingame, pexiting)
	local nod = newodds
	if (masteremeraldcd > 0) or (HugeQuest and not hq_superform.value) then
		nod = 0
	end
	return nod
end

if xItemLib then
	xItemLib.func.addItem{"XITEM_MASTEREMERALD", 
		"Master Emerald", 
		{3, "K_ITEMR4", "K_ITEMR3", "K_ITEMR2", "K_ITEMR1", "K_ITEMR2", "K_ITEMR3"}, 
		{3, "K_ISEMR4", "K_ISEMR3", "K_ISEMR2", "K_ISEMR1", "K_ISEMR2", "K_ISEMR3"},
		XIF_POWERITEM|XIF_COOLDOWNONSTART|XIF_UNIQUE,
		{ 0, 0, 0, 0, 0, 0, 1, 1, 3, 0 },
		{ 2, 1},
		GetSuper,
		UseSuper,
		nil,
		EmeraldOdds,
		nil,
		{3, {SPR_XEMR, A},{SPR_XEMR, B},{SPR_XEMR, C},{SPR_XEMR, D},{SPR_XEMR, C},{SPR_XEMR, B}},
		true,
		nil,
		nil
	}

	
	xItemLib.func.setXItemModData("XITEM_DESCRIPTIONS", "XITEM_MASTEREMERALD", {
		tipDescription1 = "Activates Super Mode",
		tipDescription2 = "Increases speed and kills other players on direct contact",
		tipUsage1 = "Extend your timer by hitting other players",
		tipUsage2 = "Sinks cannot harm you",
	})
end