local function HQ_SuperColorAssign(mo)
	if HugeQuest then return end
	if not (mo and mo.valid and mo.player) then return end
	if not mo.hqassignedcolor -- Only need this for one frame
		-- Aiai: Insert Blutz Waves here
		if (mo.skin == "aiai"
		or mo.skin == "eggman"
		or mo.skin == "ray") then
			mo.hqsupernumber = 0
			mo.hqassignedcolor = true
		-- Kuze: Heat Mode
		elseif (mo.skin == "tails"
		or mo.skin == "kuze"
		or mo.skin == "arle"
		or mo.skin == "cream"
		or mo.skin == "metalsonic") then
			mo.hqsupernumber = 1
			mo.hqassignedcolor = true
		-- Kiryu: Climax Heat Mode
		elseif (mo.skin == "knuckles" 
		or mo.skin == "kiryu"
		or mo.skin == "mighty"
		or mo.skin == "gamma"
		or mo.skin == "omega"
		or mo.skin == "darkchao"
		or mo.skin == "motobug") then
			mo.hqsupernumber = 2
			mo.hqassignedcolor = true
		-- Majima: Legend Heat Mode
		elseif (mo.skin == "blaze"
		or mo.skin == "majima"
		or mo.skin == "ulala"
		or mo.skin == "amy"
		or mo.skin == "sakura"
		or mo.skin == "espio"
		or mo.skin == "nights"
		or mo.skin == "rouge") then
			mo.hqsupernumber = 3
			mo.hqassignedcolor = true
		elseif (mo.skin == "vyse"
		or mo.skin == "chaos") then
			mo.hqsupernumber = 4
			mo.hqassignedcolor = true
		-- Copen/GV: Anthem
		elseif (mo.skin == "gunvolt" 
		or mo.skin == "copen"
		or mo.skin == "chao"
		or mo.skin == "miku") then
			mo.hqsupernumber = 5
			mo.hqassignedcolor = true
		elseif (mo.skin == "beat"
		or mo.skin == "wonderboy"
		or mo.skin == "doom"
		or mo.skin == "vector") then
			mo.hqsupernumber = 6
			mo.hqassignedcolor = true
		elseif (mo.skin == "herochao"
		or mo.skin == "aigis"
		or mo.skin == "silver") then
			mo.hqsupernumber = 7
			mo.hqassignedcolor = true
		elseif (mo.skin == "shadow") then
			mo.hqsupernumber = 8
			mo.hqassignedcolor = true
		-- Hyper Sonic
		elseif (mo.skin == "sonic"
		or mo.skin == "flicky") then
			mo.hqsupernumber = 9
			mo.hqassignedcolor = true
		else
			return 
		end
		
	end
end
addHook("MobjThinker", HQ_SuperColorAssign, MT_PLAYER)

--- Sonic 1 throwback ---
local function classicsonic(mo)
	if HugeQuest then return end
	if not (mo and mo.valid) return end
	if not (mo.target and mo.target.valid and mo.target.player) then return end
	local p = mo.target.player
	local pmo = mo.target
	if p.hugequest.super then
		if p.hugequest.supercolor == -1 then
			if p.hugequest.supershift > 5
			and p.mo.hqsupernumber ~= 9 then
				p.hugequest.supershift = 1
			end

			if p.mo.hqsupernumber ~= nil then
				mo.color = HQ_animSuper[p.mo.hqsupernumber][p.hugequest.supershift]
			else
				mo.color = HQ_animSuper[0][p.hugequest.supershift]
			end
		else
			if p.hugequest.supershift > 5
			and p.hugequest.supercolor.value ~= 9 then
				p.hugequest.supershift = 1
			end
			mo.color = HQ_animSuper[p.hugequest.supercolor][p.hugequest.supershift]
		end
		mo.colorized = true
	else
		return
	end
end
addHook("MobjThinker", classicsonic, MT_SPARKLETRAIL)

addHook("MobjThinker", function(mo)
	if HugeQuest then return end
	if not (mo and mo.valid) then return end
	
	if (mo.target and mo.target.valid)
	and (mo.target.target and mo.target.target.valid and mo.target.target.player)
	and not mo.hqsignset then
		//print("Sign linked to player.")
		//print("Did player finish in Super Form? "..mo.target.target.player.hqsuperfinish)
		if mo.target.target.player.hqsuperfinish
			mo.hqsupersign = true
			//print("Super Finish!")
		end
		mo.hqsignset = 1
		//print("Sign set.")
	end

	if mo.hqsupersign
	and not mo.hqsupergoalset then
		mo.hqsupercycle = 1
		-- Keep Sign color the same even if you change colors after the 
		-- sign spawns
		if mo.target.target.player.hugequest.supercolor == -1 then
			mo.hqsuperglow = mo.target.target.player.mo.hqsupernumber
		else
			mo.hqsuperglow = mo.target.target.player.hugequest.supercolor
		end
		mo.hqsupergoalset = 1 -- This keeps the goalpost the same in case you switch characters while a race is still underway.
	end

	if mo.hqsupergoalset then
		if leveltime%3 == 0 then
			if mo.hqsupercycle >= #HQ_animSuper[mo.hqsuperglow] then
				mo.hqsupercycle = 1
			else
				mo.hqsupercycle = $ + 1
			end
			mo.color = HQ_animSuper[mo.hqsuperglow][mo.hqsupercycle]
		end
	end
end, MT_OVERLAY)

